/*
 *  DefaultFW - 2014/09/23 하루카나소라
 *  Part of SAMI Player
 *
 *  Public Domain
 *
 */

function $(id) {return document.querySelector(id);}
function cElement(tag,insert,property,func) {
	var _DIRECT = ["className", "innerHTML", "textContent"];
	var element;
	if(!tag)
		element= document.createTextNode(property);
	else
		element= document.createElement(tag);
	if(insert) {
		var parent;
		var before = null;
		var target = null;
		if(insert.constructor === Array) {
			var target = insert[1];
			if(typeof target === "number") {
				parent = insert[0];
				before = parent.childNodes[target];
			} else {
				before = insert[0];
				parent = before.parentNode;
				if(target === "next") {
					before = before.nextSibling;
				}
			}
		} else {
			parent = insert;
		}
		if(target == 'replace')
			parent.replaceChild(element,before);
		else
			parent.insertBefore(element,before);
	}
	if(!tag)
		return element;
	if(property) {
		if(typeof property === "object") {
			for(var i in property) {
				if(property.hasOwnProperty(i)) {
					if(_DIRECT.contains(i))
						element[i] = property[i];
					else
						element.setAttribute(i, property[i]);
				}
			}
		} else {
			element.textContent = property;
		}
	}
	if(func) {
		element.addEventListener("click",func,false);
	}
	return element;
}

Array.prototype.contains = function(needle) {
	for(var i=0; i < this.length; i++) if(this[i] === needle) return true;
	return false;
}

function parseQuery(str) {
	str = str.substr(str.indexOf("?")+1);
	str = str.split("&");
	var query = {};
	var split;
	for(var i=0,l=str.length ; i<l ; i+=1) {
		split = str[i].split("=");
		query[split[0]] = split[1];
	}
	return query;
}

function ePrevent(e) {
	e.stopPropagation();
	e.preventDefault();
}

function simpleRequest(url,callback,method,headers,data) {
	var details = {method:method?method:'GET',url:url,timeout:3000};
	if(method) {
		if(method.indexOf('-b')!==-1) {
			details.responseType = 'arraybuffer';
			details.method=method.substr(0,method.length-2);
		}
	}
	if(callback) {
		if(typeof callback === 'object') {
			details.onload = function(response){callback['onload'](response);};
			details.onerror = function(response){callback['onerror'](response);};
		}
		else
			details.onload = function(response){callback(response);};
	}
	if(headers) {
		details.headers = headers;
	}
	if(data) {
		details.data = data;
	}
	xmlhttpRequest(details);
}

var xmlhttpRequest = function(details) {
		var xmlhttp = new XMLHttpRequest();
		if(details.responseType)
			xmlhttp.responseType = details.responseType;
		xmlhttp.onreadystatechange = function() {
			var responseState = {
				response:(xmlhttp.readyState===4 ? xmlhttp.response : ""),
				responseXML:(xmlhttp.readyState===4 && (xmlhttp.responseType=='' || xmlhttp.responseType=='document') ? xmlhttp.responseXML : ""),
				responseText:(xmlhttp.readyState===4 && (xmlhttp.responseType=='' || xmlhttp.responseType=='document') ? xmlhttp.responseText : ""),
				readyState:xmlhttp.readyState,
				responseHeaders:(xmlhttp.readyState===4 ? xmlhttp.getAllResponseHeaders() : ""),
				status:(xmlhttp.readyState===4 ? xmlhttp.status : 0),
				statusText:(xmlhttp.readyState===4 ? xmlhttp.statusText : "")
			};
			if(details.onreadystatechange) {
				details.onreadystatechange(responseState);
			}
			if(xmlhttp.readyState===4) {
				if(details.onload && xmlhttp.status>=200 && xmlhttp.status<300) {
					details.onload(responseState);
				}
				if(details.onerror && (xmlhttp.status<200 || xmlhttp.status>=300)) {
					details.onerror(responseState);
				}
			}
		};
		try { //cannot do cross domain
			xmlhttp.open(details.method, details.url);
		} catch(e) {
			if( details.onerror ) { //simulate a real error
				details.onerror({responseXML:"",responseText:"",readyState:4,responseHeaders:"",status:403,statusText:"Forbidden"});
			}
			return;
		}
		if(details.headers) {
			for(var prop in details.headers) {
				if(details.headers.hasOwnProperty(prop)) {
					xmlhttp.setRequestHeader(prop, details.headers[prop]);
				}
			}
		}
		xmlhttp.send( (typeof(details.data)!=="undefined")?details.data:null );
};

var htos = function(hex) {
	return atos(htoa(hex));
};

var htoa = function (hex) {
	var hex = hex.toString();
	var arr = [];
	var c=0;
	for (var i = 0; i < hex.length; i += 2)
		arr[c++] = parseInt(hex.substr(i, 2), 16);
	return arr;
};

var atos = function(arr) {
    for (var i=0, l=arr.length, s='', c; c = arr[i++];)
        s += String.fromCharCode(
            c > 0xdf && c < 0xf0 && i < l-1
                ? (c & 0xf) << 12 | (arr[i++] & 0x3f) << 6 | arr[i++] & 0x3f
            : c > 0x7f && i < l
                ? (c & 0x1f) << 6 | arr[i++] & 0x3f
            : c
        );
    return s;
}

/*
 *  SAMILoader - 2014/08/21 하루카나소라
 *  Part of SAMI Player
 *
 *  Copyright (c) 2014 Harukana Sora
 *  This file is under the terms of the MIT license.
 *
 */

var SAMILoader = function(url,callback) {
	var _this = this;
  _this.SAMIUrl = url?url:false;
	_this.delay = 0;
	_this.isLoaded= false;
	_this.timedText= new Array();

	_this.load = function(sami,callback,spliter,htmlentity) {
		var cnt = 0;
		syncs = sami.split(spliter?spliter:/<sync/gim);
		for(i in syncs) {
			sync = syncs[i];
			if(typeof sync !== "string")
				continue;
			result = sync.match(/start[^=]*=[^0-9]*([0-9]+)[^>]*>([\s\S]+)/im);
			if(result===null)
				continue;
			start = result[1];
			text = htmlentity?htmlEnDeCode.htmlDecode(result[2]):result[2];
			text = text.replace(/<p[^>]*>/gi,"");
			text = text.replace(/<font[^>]* color=[\'\"]*([^>\'\"]+)[\'\"]*[ ]*[^>]*>(.*)<\/font>/gi,"<span style=\"color:$1\">$2</span>");
			text = text.replace(/<br[^>]*>/gi,"<br>");
			text = text.replace(/[\r\n]/g,"");
			text = text.split(/<\/body>/gi)[0];
			_this.timedText[cnt] = new Array();
			_this.timedText[cnt].start= start;
			_this.timedText[cnt].text = text;
			cnt++;
		}
		_this.isLoaded= true;
		if(callback)
			callback(true);
	};
	_this.loadUrl = function(url,callback) {
		simpleRequest(url, function(r) {
			_this.SAMIUrl = url;
			_this.timedText=new Array();
			_this.load(r.responseText,callback);
		});
	};
	_this.getText = function(ms) {
		if(!_this.isLoaded)
			return false;
		for(i=_this.timedText.length;i--;) {
			if(_this.timedText[i].start<=ms-_this.delay) {
				now = _this.timedText[i];
				return now.text;
				break;
			}
		}
		return "&nbsp;";
	};

	if(url)
		_this.loadUrl(url,callback);
};

var htmlEnDeCode = (function() {
    var charToEntityRegex,
        entityToCharRegex,
        charToEntity,
        entityToChar;

    function resetCharacterEntities() {
        charToEntity = {};
        entityToChar = {};
        // add the default set
        addCharacterEntities({
            '&amp;'     :   '&',
            '&gt;'      :   '>',
            '&lt;'      :   '<',
            '&quot;'    :   '"',
            '&#39;'     :   "'"
        });
    }

    function addCharacterEntities(newEntities) {
        var charKeys = [],
            entityKeys = [],
            key, echar;
        for (key in newEntities) {
            echar = newEntities[key];
            entityToChar[key] = echar;
            charToEntity[echar] = key;
            charKeys.push(echar);
            entityKeys.push(key);
        }
        charToEntityRegex = new RegExp('(' + charKeys.join('|') + ')', 'g');
        entityToCharRegex = new RegExp('(' + entityKeys.join('|') + '|&#[0-9]{1,5};' + ')', 'g');
    }

    function htmlEncode(value){
        var htmlEncodeReplaceFn = function(match, capture) {
            return charToEntity[capture];
        };

        return (!value) ? value : String(value).replace(charToEntityRegex, htmlEncodeReplaceFn);
    }

    function htmlDecode(value) {
        var htmlDecodeReplaceFn = function(match, capture) {
            return (capture in entityToChar) ? entityToChar[capture] : String.fromCharCode(parseInt(capture.substr(2), 10));
        };

        return (!value) ? value : String(value).replace(entityToCharRegex, htmlDecodeReplaceFn);
    }

    resetCharacterEntities();

    return {
        htmlEncode: htmlEncode,
        htmlDecode: htmlDecode
    };
})();