// ==UserScript==
// @name           TVple HTML5 Player
// @namespace      http://kasugano.tistory.com
// @version        1.0.3
// @date           2014.09.23
// @author         하루카나소라
// @description    TVple에서 플래시 플레이어 대신 HTML5 플레이어를 사용합니다.
// @include        http://tvple.com/*
// @require        https://ssl-proxy.dcmys.kr/api/js/fw.js
// @require        https://ssl-proxy.dcmys.kr/api/js/pako.js
// @run-at         document-end
// ==/UserScript==
//
// _IMG만 빼고는 다른 브라우저에서도 작동할 것 같다.
// CORS 비허용인 t.tvple.com에 액세스할 수 없어서 재생할 수는 없지만..
//

var TVpleHTML5Player = function() {
	var _this = this;
	var _IMG = {
		'loading':chrome.extension.getURL('images/loader.gif'),
		'logo':chrome.extension.getURL('images/2.PNG'),
		'play':chrome.extension.getURL('images/37.PNG'),
		'pause':chrome.extension.getURL('images/40.PNG'),
		'tape_none':chrome.extension.getURL('images/gray-tape.png'),
		'tape_buff':chrome.extension.getURL('images/grad-tape.png'),
		'tape_play':chrome.extension.getURL('images/yellow-tape.png'),
		'repeat_on':chrome.extension.getURL('images/53.PNG'),
		'repeat_off':chrome.extension.getURL('images/56.PNG'),
		'cloud_on':chrome.extension.getURL('images/47.PNG'),
		'cloud_off':chrome.extension.getURL('images/50.PNG'),
		'volume_on':chrome.extension.getURL('images/71.PNG'),
		'volume_off':chrome.extension.getURL('images/74.PNG'),
		'fullscreen_on':chrome.extension.getURL('images/59.PNG'),
		'fullscreen_off':chrome.extension.getURL('images/62.PNG')
	};

	this.version = '2.40903';
	this.tick = 500;
	this.cloudEnabled = true;
	this.sami = null;
	this.load = function() {
		if(!/^\/[0-9]+$/.test(location.pathname))
			return;
		var target = $('div#play')?$('div#play'):$('object#player')?$('object#player'):null;
		if(!target)
			return alert('HTML5 플레이어 초기화 중 오류가 발생했습니다.\n\n삽입 지점을 찾을 수 없음');

		cElement('style', document.head, {'type':'text/css', 'textContent':''
			+'@import url(http://fonts.googleapis.com/earlyaccess/nanumgothic.css);'

			+'div.html5-player { width: 100%; height: 565px; position: relative; overflow: hidden; }'
			+'div.html5-player.fullscreen, div.html5-player.fullscreen > video { height: 100%; }'
			+'div.html5-player * { font-family: "Nanum Gothic", "Malgun Gothic", sans-serif; }'
			+'div.html5-player > div.html5-player-sami-container { position: absolute; bottom: 30px; left: 0; right: 0; text-align: center; display: none; pointer-events: none; z-index: 1; }'
			+'div.html5-player > div.html5-player-sami-container > div.html5-player-sami-inner-container { display: inline-block; font-size: 37px; line-height: 1.1em; color: white; text-shadow: -1px -1px 0 #000, 1px -1px 0 #000, -1px 1px 0 #000, 1px 1px 0 #000; text-align: left; }'
			+'div.html5-player > video { width: 100%; height: 535px; position: absolute; top: 0; z-index: 0; background-color: black; }'
			+'div.html5-player > div.html5-player-messagebox { position: absolute; z-index: 7; left: 0; right: 0; bottom: 0; top: 0; text-align: center; line-height: 565px; pointer-events: none; }'
			+'div.html5-player > div.html5-player-messagebox > div { display: inline-block; line-height: 1em; background-color: white; opacity: .9; font-size: 1.5em; border-radius: 5px; background-size: 32px; background-repeat: no-repeat; background-position: 50% 25px; padding: 20px 50px; }'
			+'div.html5-player > div.html5-player-messagebox > div.loading { padding: 70px 50px 20px 50px; background-image: url("' + _IMG.loading + '"); }'
			+'div.html5-player > div.html5-player-cloud-container { width: 100%; height: 535px; position: absolute; top: 0; z-index: 2; pointer-events: none; }'
			+'div.html5-player > div.html5-player-cloud-container > div.html5-player-cloud-inner-container { position: relative; width: 100%; height: 100%; }'
			+'div.html5-player > div.html5-player-cloud-container > div.html5-player-cloud-inner-container > div.html5-player-cloud { position: absolute; color: white; font-family: "Nanum Gothic"; font-weight: bold; text-shadow: 0 0 5px black; transition: opacity 300ms; opacity: .7; white-space: nowrap; }'
			+'div.html5-player > div.html5-player-control-logo { position: absolute; pointer-events: none; width: 70px; height: 36px; background-image: url("' + _IMG.logo + '"); z-index: 1; right: 10px; bottom: 40px; opacity: .5; }'
			+'div.html5-player > div.html5-player-control-container { height: 30px; bottom: 0; left: 0; right: 0; position: absolute; z-index: 3; transition: opacity 300ms; opacity: 1; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container { position: relative; width: 100%; height: 100%; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div { position: absolute; height: 100%; background-position: left top; background-repeat: no-repeat; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-play { left: 0; width: 40px; background-image: url("' + _IMG.play + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-pause { left: 0; width: 40px; background-image: url("' + _IMG.pause + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-duration { position: absolute; left: 40px; z-index: 5; line-height: 30px; margin-left: 10px; font-weight: bold; color: white; text-shadow: 0 0 5px black;pointer-events: none; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-seek { left: 40px; width: 790px; background-repeat: repeat-x; background-image: url("' + _IMG.tape_none + '"); z-index: 4; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-seek > div { width: 100%; height: 100%; position: relative; background-repeat: no-repeat; background-size: 100%; pointer-events: none; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-seek > div > div { position: absolute; opacity: .6; left: 0; width: 0px; height: 100%; background-size: inherit; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-seek > div > div.html5-player-control-seek-buff { background-image: url("' + _IMG.tape_buff + '"); z-index: 5; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-seek > div > div.html5-player-control-seek-play { background-image: url("' + _IMG.tape_play + '"); z-index: 6; }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-repeat-on { right: 90px; width: 30px; background-image: url("' + _IMG.repeat_on + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-repeat-off{ right: 90px; width: 30px; background-image: url("' + _IMG.repeat_off + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-cloud-on { right: 60px; width: 30px; background-image: url("' + _IMG.cloud_on + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-cloud-off{ right: 60px; width: 30px; background-image: url("' + _IMG.cloud_off + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-volume-on { right: 30px; width: 30px; background-image: url("' + _IMG.volume_on + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-volume-off{ right: 30px; width: 30px; background-image: url("' + _IMG.volume_off + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-fullscreen-on { right: 0; width: 30px; background-image: url("' + _IMG.fullscreen_on + '"); }'
			+'div.html5-player > div.html5-player-control-container > div.html5-player-control-inner-container > div.html5-player-control-fullscreen-off{ right: 0; width: 30px; background-image: url("' + _IMG.fullscreen_off + '"); }'
			});

		_this.msgbox("플레이어 초기화 중...", true);

		_this.playerDiv = cElement('div', [target,'replace'], {'className':'html5-player'});
		cElement('div', _this.playerDiv, {'className':'html5-player-control-logo'});
		_this.cloudDiv  = cElement('div', cElement('div', _this.playerDiv, {'className':'html5-player-cloud-container'}), {'className':'html5-player-cloud-inner-container'});
		_this.samiDiv  = cElement('div', cElement('div', _this.playerDiv, {'className':'html5-player-sami-container'}), {'className':'html5-player-sami-inner-container'});
		_this.controlDiv = cElement('div', cElement('div', _this.playerDiv, {'className':'html5-player-control-container'}), {'className':'html5-player-control-inner-container'});
		cElement('div', _this.controlDiv, {'className':'html5-player-control-play'}, function() {
			if(_this.playerVid.paused)
				_this.playerVid.play();
			else
				_this.playerVid.pause();
		});
		_this.controlSeek = cElement('div', cElement('div', _this.controlDiv, {'className':'html5-player-control-seek'}));
		cElement('div', _this.controlSeek, {'className':'html5-player-control-seek-buff'});
		cElement('div', _this.controlSeek, {'className':'html5-player-control-seek-play'});
		_this.durationText= cElement('div', _this.controlDiv,  {'className':'html5-player-control-duration'});

		cElement('div', _this.controlDiv, {'className':'html5-player-control-repeat-on'}, function() { _this.playerVid.loop=!_this.playerVid.loop; this.className = 'html5-player-control-repeat-'+(_this.playerVid.loop?'on':'off'); });
		cElement('div', _this.controlDiv, {'className':'html5-player-control-cloud-on'}, function() { 
			_this.cloudEnabled=!_this.cloudEnabled; 
			this.className = 'html5-player-control-cloud-'+(_this.cloudEnabled?'on':'off'); 
			if(!_this.cloudEnabled)
				_this.cloudDiv.innerHTML = '';
		});
		cElement('div', _this.controlDiv, {'className':'html5-player-control-volume-on'});
		cElement('div', _this.controlDiv, {'className':'html5-player-control-fullscreen-on'}, function() {
			if(isFullscreen())
        _this.exitFullscreen();
			else
        _this.goFullscreen();
		});
		
		document.addEventListener('webkitfullscreenchange', FullscreenHandler, false);
    document.addEventListener('mozfullscreenchange', FullscreenHandler, false);
    document.addEventListener('fullscreenchange', FullscreenHandler, false);
    document.addEventListener('MSFullscreenChange', FullscreenHandler, false);

		_this.controlSeek.parentNode.addEventListener('mousedown', function(e) { _this.controlSeek.dragging = true; _this.playerVid.pause(); });
		_this.controlSeek.parentNode.addEventListener('mousemove', function(e) { 
			if(!_this.controlSeek.dragging) 
				return; 
			_this.playerVid.currentTime = _this.playerVid.duration*e.layerX/_this.controlSeek.clientWidth;
		});
		_this.controlSeek.parentNode.addEventListener('mouseup', function(e) { _this.controlSeek.dragging = false; _this.playerVid.play(); });

		var keyReg = /flashvars\.key = \'([^\']+)\'/;
		if(!keyReg.test(document.body.innerHTML))
			return _this.msgbox("KEY가 전달되지 않았습니다.");

		var data = keyReg.exec(document.body.innerHTML)[1];
		if(!data)
			return _this.msgbox("KEY가 올바르지 않습니다.");

		data = parseKey(data);
		if(!data)
			return _this.msgbox("KEY가 올바르지 않습니다.");

		var data2 = data.split("\n");
		_this.info = data2;

		if(data2[0] != _this.version)
		{
			return _this.msgbox("서버와 호환되지 않습니다.<br>페이지를 새로고침 해보세요!<br>서버: " + data2[0]);
		}
		_this.playerDiv.style.backgroundColor = '#' + data2[1];
		_this.playerVid = cElement('video', _this.playerDiv, {'preload':'none'});
		window.addEventListener('resize', Resize);

		_this.msgbox("정보 수신 중...", true);

		setTimeout(function() {
			try
			{
				simpleRequest(data2[3], {'onload':videoInfoCallback,'onerror':function(e) { _this.msgbox("정보 HTTP 오류: " + e.status); }});
			}
			catch (e)
			{
				_this.msgbox("정보 수신 예외 오류");
			}
		}, 700);
	};

	this.msgbox = function(str,loading,timeout) {
		var box=$('div.html5-player-messagebox');
		if(!box) {
			box=cElement('div', _this.playerDiv, {'className':'html5-player-messagebox'}); 
			cElement('div', box);
		}
		box.firstChild.className = loading?'loading':null;
		box.firstChild.innerHTML=str;

		if(!str) box.parentNode.removeChild(box);
	};

	this.goFullscreen = function() {
		var i = _this.playerDiv;
		if (i.requestFullscreen) {
				i.requestFullscreen();
		} else if (i.webkitRequestFullscreen) {
				i.webkitRequestFullscreen();
		} else if (i.mozRequestFullScreen) {
				i.mozRequestFullScreen();
		} else if (i.msRequestFullscreen) {
				i.msRequestFullscreen();
		}
	}

	this.exitFullscreen = function() {
		if (document.exitFullscreen) {
			document.exitFullscreen();
		} else if (document.webkitExitFullscreen) {
			document.webkitExitFullscreen();
		} else if (document.mozCancelFullScreen) {
			document.mozCancelFullScreen();
		} else if (document.msExitFullscreen) {
			document.msExitFullscreen();
		}
	}

	var isFullscreen = function() {
    if(document.fullscreenEnabled || document.webkitFullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled) {
			return document.fullscreenElement || document.webkitFullscreenElement || document.mozFullScreenElement || document.msFullscreenElement;
    }
		return false;
	}

	var FullscreenHandler = function() {
		if(isFullscreen()) {
			this.className = 'html5-player-control-fullscreen-off';
			_this.playerDiv.classList.add('fullscreen');
			Resize();
		}else {
			this.className = 'html5-player-control-fullscreen-on';
			_this.playerDiv.classList.remove('fullscreen');
			Resize();
    }
	};

	var Resize = function() {
		_this.controlSeek.parentNode.style.width = (_this.controlDiv.clientWidth-160) + 'px';
		var hr = _this.playerVid.clientHeight/_this.playerVid.videoHeight;
		var wr = _this.playerVid.clientWidth/_this.playerVid.videoWidth;
		var rate = hr<wr?hr:wr;
		var videoHeight = _this.playerVid.videoHeight * rate;
		var videoWidth = _this.playerVid.videoWidth * rate;
		_this.cloudDiv.parentNode.style.top = (_this.playerVid.clientHeight-videoHeight)/2 + 'px';
		_this.cloudDiv.parentNode.style.left = (_this.playerVid.clientWidth-videoWidth)/2 + 'px';
		_this.cloudDiv.parentNode.style.width = videoWidth + 'px';
		_this.cloudDiv.parentNode.style.height= videoHeight + 'px';
		_this.cloudDiv.parentNode.style.fontSize= rate + 'em';
		_this.samiDiv.style.fontSize= (_this.playerVid.clientWidth * 0.03) + "px";
		tickCallback();
	}

	var setCursorTimeout = function(query, ms) {
		clearTimeout($(query).timeoutClock);
		$(query).timeoutClock = setTimeout(function() { $(query).style.cursor = "none"; $("div.html5-player-control-container").style.opacity="0"; }, ms);
	}


	var videoInfoCallback = function(r) {
		if(r.responseText.substr(0,4) == "오류: ")
			return _this.msgbox(r.responseText.substr(4));

		var xmlText = parseKey(r.responseText);
		if(!xmlText)
			return _this.msgbox("정보가 올바르지 않습니다.");
		try
		{
			var videoinfo=(new DOMParser()).parseFromString(xmlText,"text/xml");
			console.log(videoinfo);
		}
		catch (e)
		{
			return _this.msgbox("정보 XML 오류");
		}
		if(videoinfo.q('tvple > version').textContent != _this.version)
			return _this.msgbox("티켓 서버와 호환되지 않습니다.<br>플레이어 업데이트가 필요합니다.<br>서버 버전: " + videoinfo.q('tvple > version').textContent + "<br>HTML5 플레이어 버전: " + _this.version);
		if(videoinfo.q('tvple > video > state').textContent !== "0")
			return _this.msgbox("동영상이 삭제되었거나 재생할 수 없는 상태입니다.");

		_this.playerVid.setAttribute('poster', videoinfo.q('tvple > video > preview > url').textContent);
		cElement('source', _this.playerVid, {'type':'video/mp4','src':videoinfo.q('tvple > video > url').textContent});
		_this.playerVid.load();
		_this.playerVid.addEventListener('loadedmetadata', Resize);

		_this.msgbox("Misc 데이터 수신 중...", true);
		try
		{	
			simpleRequest(videoinfo.q('tvple > misc > url').textContent, {'onload':miscCallback,'onerror':function(e) { _this.msgbox("Misc 서버 HTTP 오류: " + e.status); }}, 'GET-b');
		}
		catch (e)
		{
			return _this.msgbox("Misc 데이터 수신 예외 오류");
		}
	
		try
		{
			_this.playerVid.loop = true;
			_this.playerVid.addEventListener("play", function() { 
				if($('div.html5-player-control-play'))
					$('div.html5-player-control-play').className = 'html5-player-control-pause';
			});
			_this.playerVid.addEventListener("pause", function() { 
				if($('div.html5-player-control-pause'))
					$('div.html5-player-control-pause').className = 'html5-player-control-play';
			});
			_this.playerVid.addEventListener("progress", function() {
				try
				{
					$('div.html5-player-control-seek-buff').style.left = $('div.html5-player-control-seek').clientWidth * _this.playerVid.buffered.start(0)/_this.playerVid.duration + 'px';
					$('div.html5-player-control-seek-buff').style.width = $('div.html5-player-control-seek').clientWidth * (_this.playerVid.buffered.end(0)-_this.playerVid.buffered.start(0))/_this.playerVid.duration + 'px';
				}
				catch (e)
				{
					$('div.html5-player-control-seek-buff').style.left = '0px';
					$('div.html5-player-control-seek-buff').style.width = '0px';
				}
			});
			_this.playerVid.addEventListener("waiting", function() {
				_this.msgbox("버퍼링...", true);
			});
			_this.playerVid.addEventListener("playing", function() {
				_this.msgbox(null);
			});
			_this.playerVid.addEventListener("mousemove", function(e) {
				if(this.lastx == e.x && this.lasty == e.y)
					return;
				this.lastx = e.x;
				this.lasty = e.y;
				this.style.cursor = "default";
				$("div.html5-player-control-container").style.opacity="1";
				if(isFullscreen())
					setCursorTimeout("div.html5-player > video", 1000);
			});
			_this.playerVid.addEventListener("timeupdate", tickCallback);
		}
		catch (e)
		{
			return _this.msgbox("HTML5 Player 초기화 중 오류가 발생하였습니다.");
		}
	};

	var miscCallback = function(r) {
		var byteArray = new Uint8Array(r.response);
		try
		{
			var inflated = pako.inflate(byteArray,{to:'string'});			
		}
		catch (e)
		{
			return _this.msgbox("Misc 데이터를 풀지 못했습니다.");
		}
		if(inflated.substr(0,4) == "오류: ")
			return _this.msgbox(inflated.substr(4));
		var parsedText=parseKey(inflated);
		if(!parsedText)
			return _this.msgbox("Misc 데이터가 올바르지 않습니다.");
		try
		{
			var cloudXmlDOM=(new DOMParser()).parseFromString(parsedText,"text/xml");
		}
		catch (e)
		{
			return _this.msgbox("Misc 데이터 XML 오류");
		}

		parsedText=null;
		if(!cloudXmlDOM)
			return _this.msgbox("Misc 데이터 XML 오류");
		_this.msgbox(null);
		var tmpArr=null;
		if(cloudXmlDOM.q('tvple > cloud > item > _id'))
			tmpArr = new Array(cloudXmlDOM.q('tvple > cloud > item'));
		else if(cloudXmlDOM.q('tvple > cloud > item'))
			tmpArr = cloudXmlDOM.qAll('tvple > cloud > item');
		else
			_this.cloudArr = null;

		if(cloudXmlDOM.q('tvple > subtitle')) {
			_this.sami = new SAMILoader();
			_this.sami.load(cloudXmlDOM.q('tvple > subtitle').innerHTML,
				function() { 
					_this.sami.tick = setInterval(function() {
						if(_this.sami.isLoaded) {
							var ms = parseInt(_this.playerVid.currentTime*1000);
							var text = _this.sami.getText(ms);
							if(text!==false) {
								_this.samiDiv.innerHTML = text;
								_this.samiDiv.parentNode.style.display="block";
							}
						}
						else
							clearInterval(_this.sami.tick);
					},100);
			},/<item/gim,true);
			
		}

		if(tmpArr) {
			_this.cloudArr = new Array();
			for(i=tmpArr.length;i--;) {
				_this.cloudArr[i] = new Array();
				for(j=tmpArr[i].attributes.length;j--;) {
					_this.cloudArr[i][tmpArr[i].attributes[j].nodeName] = tmpArr[i].attributes[j].value;
				}
				if(tmpArr[i].textContent)
					_this.cloudArr[i]['text'] = tmpArr[i].textContent;
			}
		}

		tmpArr = null;

		tickCallback();
		if(_this.info[4])
			_this.playerVid.play();
	};

	var timetostr = function(time) {
		min = parseInt(time/60);
		sec = parseInt(time%60);
		return (min?min<10?'0'+min:min:'00') + ':' + (sec?sec<10?'0'+sec:sec:'00');
	};

	var tickCallback = function() {
		_this.durationText.textContent = timetostr(_this.playerVid.currentTime) + ' / ' + timetostr(_this.playerVid.duration);
		$('div.html5-player-control-seek-play').style.width = _this.controlSeek.clientWidth * _this.playerVid.currentTime/_this.playerVid.duration + 'px';

		if(_this.cloudArr && _this.cloudEnabled) {
			if(_this.playerVid.videoHeight == 0 || _this.playerVid.videoWidth == 0)
				return;
			var ct = _this.playerVid.currentTime;
			var hr = _this.playerVid.clientHeight/_this.playerVid.videoHeight;
			var wr = _this.playerVid.clientWidth/_this.playerVid.videoWidth;
			var rate = hr<wr?hr:wr;
			for(i=_this.cloudArr.length;i--;) {
				if(_this.cloudArr[i]['pos']<=ct && _this.cloudArr[i]['pos']>ct-2 && $('div#html5-player-cloud-'+_this.cloudArr[i]['id'])===null) {
					cloud = cElement('div', _this.cloudDiv, {'id':'html5-player-cloud-'+_this.cloudArr[i]['id'],'className':'html5-player-cloud','textContent':_this.cloudArr[i]['text']});
					cloud.style.top = (_this.cloudArr[i]['y']*rate) + 'px';
					cloud.style.left = (_this.cloudArr[i]['x']*rate) + 'px';
				}
				else if(_this.cloudArr[i]['pos']<=ct-2.3 && $('div#html5-player-cloud-'+_this.cloudArr[i]['id'])) {
					$('div#html5-player-cloud-'+_this.cloudArr[i]['id']).parentNode.removeChild($('div#html5-player-cloud-'+_this.cloudArr[i]['id']));
				}
				else if(_this.cloudArr[i]['pos']<=ct-2 && $('div#html5-player-cloud-'+_this.cloudArr[i]['id'])) {
					$('div#html5-player-cloud-'+_this.cloudArr[i]['id']).style.opacity='0';
				}
			}
			ct=hr=wr=fs=null;
		}
	};
};

var parseKey = function(q) {
	if(q.substr(0,4) != 'feff' || q.substr(20,1) != '_') {
		return false;
	}
	var subtbl = q.substr(69,16).split("");
	return htos(q.substr(125).split("").reverse().join("").replace(new RegExp(subtbl[5],"g"),"g").replace(new RegExp(subtbl[4],"g"),"h").replace(new RegExp(subtbl[3],"g"),"i").replace(new RegExp(subtbl[2],"g"),"j").replace(new RegExp(subtbl[1],"g"),"k").replace(new RegExp(subtbl[6],"g"),subtbl[5]).replace(new RegExp(subtbl[7],"g"),subtbl[4]).replace(new RegExp(subtbl[8],"g"),subtbl[3]).replace(new RegExp(subtbl[9],"g"),subtbl[2]).replace(new RegExp(subtbl[10],"g"),subtbl[1]).replace(new RegExp("g","g"),subtbl[6]).replace(new RegExp("h","g"),subtbl[7]).replace(new RegExp("i","g"),subtbl[8]).replace(new RegExp("j","g"),subtbl[9]).replace(new RegExp("k","g"),subtbl[10]));
};

var loadScript = function(url, callback) {
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = url;
    script.onreadystatechange = callback;
    script.onload = callback;
    head.appendChild(script);
};

var loadZlib = function(callback) {
	if(!pako) {
		loadScript('https://ssl-proxy.dcmys.kr/api/js/pako.js',callback);
	}
	callback();
};

XMLDocument.prototype.q = XMLDocument.prototype.querySelector;
XMLDocument.prototype.qAll = XMLDocument.prototype.querySelectorAll;

//////////////////////////////////////
var player = new TVpleHTML5Player();
if(typeof simpleRequest == 'undefined')
	loadScript('https://ssl-proxy.dcmys.kr/api/js/fw.js', function() { loadZlib(player.load); });
else
	loadZlib(player.load);